/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Software
 *
 *  Copyright (C) 2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 *
 *  {\tgEFÁCAUTOSARiAUTomotive Open System ARchitecturejd
 *  lɊÂĂDL̋́CAUTOSAR̒mIŶ
 *  ͂ȂDAUTOSAŔCAUTOSARdlɊÂ\tgEFApړIŗ
 *  p҂ɑ΂āCAUTOSARp[gi[ɂȂ邱Ƃ߂ĂD
 *  
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 *
 *  $Id: fcan.c 330 2013-08-14 14:12:18Z honda $
 */

/*
 * {j
 * E݂gpȂ
 * E`l̃obt@̓[{bNXƕ\0̔ԍƂĈ
 *  
 * M
 * EMobt@(16)pĒʐM
 *
 * M 
 * EMobt@(16)pĒʐM
 * EM[16 
 */
#include "Os.h"
#include "rscan.h"
#include "t_syslog.h"
#include "t_stdlib.h"
#include "sysmod/serial.h"
#include "sysmod/syslog.h"


/*
 *  萔`
 */
#define TNUM_RX_BUFF		16U

/* Mobt@ԍ */
#define CAN_TX_BUFF_NO(ch, id)	((ch) * 16U + id)

/* Mobt@ԍ */
#define CAN_RX_BUFF_NO(ch, id)	((ch) * TNUM_RX_BUFF + id)

/* M[ */
#define TNUM_RXRULE			16U


/* rbgp */
#define CAN_BIT0	0x00000001U
#define CAN_BIT1	0x00000002U
#define CAN_BIT2	0x00000004U
#define CAN_BIT3	0x00000008U
#define CAN_BIT4	0x00000010U
#define CAN_BIT5	0x00000020U
#define CAN_BIT6	0x00000040U
#define CAN_BIT7	0x00000080U
#define CAN_BIT8	0x00000100U
#define CAN_BIT9	0x00000200U
#define CAN_BIT10	0x00000400U
#define CAN_BIT11	0x00000800U
#define CAN_BIT12	0x00001000U
#define CAN_BIT13	0x00002000U
#define CAN_BIT14	0x00004000U
#define CAN_BIT15	0x00008000U
#define CAN_BIT16	0x00010000U
#define CAN_BIT17	0x00020000U
#define CAN_BIT18	0x00040000U
#define CAN_BIT19	0x00080000U
#define CAN_BIT20	0x00100000U
#define CAN_BIT21	0x00200000U
#define CAN_BIT22	0x00400000U
#define CAN_BIT23	0x00800000U
#define CAN_BIT24	0x01000000U
#define CAN_BIT25	0x02000000U
#define CAN_BIT26	0x04000000U
#define CAN_BIT27	0x08000000U
#define CAN_BIT28	0x10000000U
#define CAN_BIT29	0x20000000U
#define CAN_BIT30	0x40000000U
#define CAN_BIT31	0x80000000U

/* O[o */
#define RSCAN0GCFG					(*(volatile uint32 *) (RSCAN0_BASE + 0x0084U))
#define RSCAN0GCTR					(*(volatile uint32 *) (RSCAN0_BASE + 0x0088U))
#define RSCAN0GSTS					(*(volatile uint32 *) (RSCAN0_BASE + 0x008CU))
#define RSCAN0GAFLCFG0				(*(volatile uint32 *) (RSCAN0_BASE + 0x009CU))
#define RSCAN0GAFLCFG1				(*(volatile uint32 *) (RSCAN0_BASE + 0x00A0U))
#define RSCAN0GAFLECTR				(*(volatile uint32 *) (RSCAN0_BASE + 0x0098U))

/* Mobt@ */
#define RSCAN0RMNB					(*(volatile uint32 *) (RSCAN0_BASE + 0x00A4U))
#define RSCAN0RMND(y)				(*(volatile uint32 *) (RSCAN0_BASE + 0x00A8U + ((y) * 0x04)))
#define RSCAN0RMID(id)				(*(volatile uint32 *) (RSCAN0_BASE + 0x0600U + ((id) * 0x10)))
#define RSCAN0RMPTQ(id)				(*(volatile uint32 *) (RSCAN0_BASE + 0x0604U + ((id) * 0x10)))
#define RSCAN0RMDF0(id, byte)		(*(volatile uint8 *) (RSCAN0_BASE + 0x0608U + ((id) * 0x10) + (byte)))
#define RSCAN0RMDF1(id, byte)		(*(volatile uint8 *) (RSCAN0_BASE + 0x060CU + ((id) * 0x10) + (byte)))

/* `l */
#define RSCAN0CmCFG(ch)				(*(volatile uint32 *) (RSCAN0_BASE + 0x0000U + ((ch) * 0x10U)))
#define RSCAN0CmCTR(ch)				(*(volatile uint32 *) (RSCAN0_BASE + 0x0004U + ((ch) * 0x10U)))
#define RSCAN0CmSTS(ch)				(*(volatile uint32 *) (RSCAN0_BASE + 0x0008U + ((ch) * 0x10U)))
#define RSCAN0THLCC(ch)				(*(volatile uint32 *) (RSCAN0_BASE + 0x0400U + ((ch) * 0x04U)))

/* M[ */
#define RSCAN0GAFLID(rule)			(*(volatile uint32 *) (RSCAN0_BASE + 0x0500U + ((rule) * 0x10U)))
#define RSCAN0GAFLM(rule)			(*(volatile uint32 *) (RSCAN0_BASE + 0x0504U + ((rule) * 0x10U)))
#define RSCAN0GAFLP0(rule)			(*(volatile uint32 *) (RSCAN0_BASE + 0x0508U + ((rule) * 0x10U)))
#define RSCAN0GAFLP1(rule)			(*(volatile uint32 *) (RSCAN0_BASE + 0x050CU + ((rule) * 0x10U)))

/* MFIFOobt@(Mp) */
#define RSCAN0CFCC(buf_no)			(*(volatile uint32 *) (RSCAN0_BASE + 0x0118U + ((buf_no) * 0x04U)))
#define RSCAN0CFSTS(buf_no)			(*(volatile uint32 *) (RSCAN0_BASE + 0x0178U + ((buf_no) * 0x04U)))
#define RSCAN0CFPCTR(buf_no)		(*(volatile uint32 *) (RSCAN0_BASE + 0x01D8U + ((buf_no) * 0x04U)))
#define RSCAN0CFID(buf_no)			(*(volatile uint32 *) (RSCAN0_BASE + 0x0E80U + ((buf_no) * 0x10U)))
#define RSCAN0CFPTR(buf_no)			(*(volatile uint32 *) (RSCAN0_BASE + 0x0E84U + ((buf_no) * 0x10U)))
#define RSCAN0CFDF0(buf_no, byte)	(*(volatile uint8 *) (RSCAN0_BASE + 0x0E88U + ((buf_no) * 0x10U) + (byte)))
#define RSCAN0CFDF1(buf_no, byte)	(*(volatile uint8 *) (RSCAN0_BASE + 0x0E8CU + ((buf_no) * 0x10U) + (byte)))

/* Mobt@ */
#define RSCAN0TMC(buf_no)			(*(volatile uint8 *)  (RSCAN0_BASE + 0x0250U + (buf_no)))
#define RSCAN0TMSTS(buf_no)			(*(volatile uint8  *) (RSCAN0_BASE + 0x02D0U + ((buf_no) * 0x01U)))
#define RSCAN0TMID(buf_no)			(*(volatile uint32 *) (RSCAN0_BASE + 0x1000U + ((buf_no) * 0x10U)))
#define RSCAN0TMPTR(buf_no)			(*(volatile uint32 *) (RSCAN0_BASE + 0x1004U + ((buf_no) * 0x10U)))
#define RSCAN0TMDF0(buf_no, byte)	(*(volatile uint8 *) (RSCAN0_BASE + 0x1008U + ((buf_no) * 0x10U) + (byte)))
#define RSCAN0TMDF1(buf_no, byte)	(*(volatile uint8 *) (RSCAN0_BASE + 0x100CU + ((buf_no) * 0x10U) + (byte)))


/* ML[ */
#define RSCAN0TXQCC(ch)				(*(volatile uint32 *) (RSCAN0_BASE + 0x03A0U + ((ch) * 0x04U)))
#define RSCAN0TXQSTS(ch)			(*(volatile uint32 *) (RSCAN0_BASE + 0x03C0U + ((ch) * 0x04U)))
#define RSCAN0TXQPCTR(ch)			(*(volatile uint32 *) (RSCAN0_BASE + 0x03E0U + ((ch) * 0x04U)))

/* M */
#define RSCAN0THLSTS(ch)			(*(volatile uint32 *) (RSCAN0_BASE + 0x0420U + ((ch) * 0x04U)))
#define RSCAN0THLACC(ch)			(*(volatile uint32 *) (RSCAN0_BASE + 0x1800U + ((ch) * 0x04U)))
#define RSCAN0THLPCTR(ch)			(*(volatile uint32 *) (RSCAN0_BASE + 0x0440U + ((ch) * 0x04U)))

/* C_ISO_CANOSCNbNWX^ */
#define CKSC_ICANOSCD_CTL			0xFFF8AA00U

/* M[ݒ(ch0`3)p */
#define GAFLCFG0_REG_BIT_SHIFT(ch)	(24U - ((ch) * 8U))

/* M[ݒ(ch4`5)p */
#define GAFLCFG1_REG_BIT_SHIFT(ch)	(24U - (((ch) - 4U) * 8U))


STATUS
RsCanInit(uint8 ctrl_id) {
	/*
	 *  O[oȏ
	 */
	/* CANpRAMNAXe[^XtO`FbN */
	if ((RSCAN0GSTS & CAN_BIT3) != 0U) {
		return STATUS_ERROR;
	}

	/* O[oXgbv[h */
	RSCAN0GCTR &= ~CAN_BIT2;

	/* O[oZbg[hɑJ */
	RSCAN0GCTR |= CAN_BIT0;

	/* CANŎgpNbNCKSCLK_ICANOSC(clk_xincan)ɐݒ */
	RSCAN0GCFG |= CAN_BIT4;

	/*
	 *  `l̏
	 */
	/* `lXgbv[h */
	RSCAN0CmCTR(ctrl_id) &= ~CAN_BIT2;

	/* [CAN259] `lZbg[hɑJ */
	RSCAN0CmCTR(ctrl_id) |= CAN_BIT0;

	/*
	 * Mݒ
	 */
	/* ML[͎gpȂ */
	RSCAN0TXQCC(ctrl_id) = 0x00;

	/* Mobt@͎gpȂ */
	RSCAN0THLCC(ctrl_id) = 0x00;

	/*
	 *  Mݒ
	 */
	/* Rg[4chȏォ*/
	if (ctrl_id < 4U) {
		/* M[ݒ(ch0`3) */
		RSCAN0GAFLCFG0 |= TNUM_RXRULE << GAFLCFG0_REG_BIT_SHIFT(ctrl_id);
	}
	else {
		/* M[ݒ(ch4`5) */
		RSCAN0GAFLCFG1 |= TNUM_RXRULE << GAFLCFG1_REG_BIT_SHIFT(ctrl_id);
	}

	/*
	 *  {[[g̐ݒ
	 */
	/* `lRtBO[Vݒ({[[g:500kbps) */
	RSCAN0CmCFG(ctrl_id) = RSCAN_BRP_500;

	return STATUS_OK;
}


void
RsCanEnable(uint8 ctrl_id){
	/* O[oZbg[hO[o샂[hɑJ */
	RSCAN0GCTR &= ~(CAN_BIT1 | CAN_BIT0);

	/* [CAN261] `lʐM[hɑJ */
	RSCAN0CmCTR(ctrl_id) &= ~(CAN_BIT1 | CAN_BIT0);

	/* `lʐM[hɂȂ܂Ń[v(#67) */
	while ((RSCAN0CmSTS(ctrl_id) &CAN_BIT7) == 0U) {
	}

	/* Mobt@ݒ */
	RSCAN0RMNB = TNUM_RX_BUFF * TNUM_CH;
}

void
RsCanDisable(uint8 ctrl_id) {
	/* `lZbg[hɑJ */
	RSCAN0CmCTR(ctrl_id) &= 0xFFFFFFFDU;
}


STATUS
RsCanSetTxData(uint8 ctrl_id, uint8 mb_id, uint32 id, uint8 *p_data, uint8 len){
	uint32			tm_bit;
	uint8			i;

	/* MȂ烊^[  */
	if((RSCAN0TMSTS(CAN_TX_BUFF_NO(ctrl_id, mb_id)) & CAN_BIT0) == CAN_BIT0) {
		return STATUS_SENDING;
	}

	RSCAN0TMSTS(CAN_TX_BUFF_NO(ctrl_id, mb_id)) = 0;

	/* CAN-IDݒ */
	RSCAN0TMID(CAN_TX_BUFF_NO(ctrl_id, mb_id)) = id;

	/* DLCƑMx擾 */
	tm_bit = (uint32) len << 28U;
	tm_bit |= (uint32) 2 << 16U;
	
	/* DLCƑMxݒ */
	RSCAN0TMPTR(CAN_TX_BUFF_NO(ctrl_id, mb_id)) = tm_bit;

	/* [CAN059][CAN427] f[^i[ */
	/* f[^ݒ(0`3oCg) */
	for (i = 0U; i < 4U; i++) {
		RSCAN0TMDF0(CAN_TX_BUFF_NO(ctrl_id, mb_id), i) = p_data[i];
	}
	
	/* 4oCgȍ~̃bZ[WL */
	if (len > 4U) {
		/* f[^ݒ(4`7oCg) */
		for (i = 4U; i < len; i++) {
			RSCAN0TMDF1(CAN_TX_BUFF_NO(ctrl_id, mb_id), (i - 4U)) = p_data[i];
		}
	}

	/* Mv */
	RSCAN0TMC(CAN_TX_BUFF_NO(ctrl_id, mb_id)) = CAN_BIT0;

	return STATUS_OK;
}


STATUS
RsCanSetMailBoxInfo(uint8 ctrl_id, uint8 mb_id, uint8 direction,
					uint8 ide, uint32 id, uint8 mask, uint32 remote){
	static uint8	rx_rule_index_cnt = 0U;
	uint8			rx_rule_index;

	if(direction == 1) {
		return STATUS_ERROR;
	}

	/* M[e[u݋ */
	RSCAN0GAFLECTR |= CAN_BIT8;

	/* [ԍ̒o */
	rx_rule_index = rx_rule_index_cnt % 16U;

	/* y[Wԍ؂ւ邩 */
	if (rx_rule_index == 0U) {
		/* y[Wԍݒ */
		RSCAN0GAFLECTR = (CAN_BIT8 | (uint32) (rx_rule_index_cnt / 16U));
	}

	/* tB^}XNݒ */
	RSCAN0GAFLM(rx_rule_index) = (CAN_BIT31 | mask);

	/* M[IDݒ(CAN-IDWX^) */
	RSCAN0GAFLID(rx_rule_index) = (uint32) id;

	/* M[gpMobt@̎w */
	RSCAN0GAFLP0(rx_rule_index) = (1 << 15U) | (1 << 16U) | (mb_id << 8U);

	/* M[CfbNXCNg */
	rx_rule_index_cnt++;

	/* M[e[u݋֎~ */
	RSCAN0GAFLECTR &= ~CAN_BIT8;
	
	return STATUS_OK;
 }



STATUS
RsCanGetRxData(uint8 ctrl_id, uint8 mb_id, uint8 *p_data, uint8 *p_len){
	uint8	local_dlc;
	uint8	i;
	uint8	bufid;

	bufid = CAN_RX_BUFF_NO(ctrl_id, mb_id);

	/* MĂ邩mF ToDo ͌߂ */
	if((RSCAN0RMND(bufid / 32) & (1U << (bufid % 32))) == 0) {
		*p_len = 0;
		return STATUS_EMPTY;
	}

	/* tONA */
	RSCAN0RMND(bufid / 32) = ~(1U << (bufid % 32));

	local_dlc = (RSCAN0RMPTQ(mb_id) >> 28);
	*p_len = local_dlc;

	/* f[^i[(0`3oCg) */
	for (i = 0U; i < 4U; i++) {
		p_data[i] = RSCAN0RMDF0(mb_id, i);
	}

	/* f[^4byteȏォ */
	if (local_dlc > 4U) {
		/* f[^i[(4`7oCg) */
		for (i = 4U; i < local_dlc; i++) {
			p_data[i] = RSCAN0RMDF1(mb_id, (i - 4U));
		}
	}

	return STATUS_OK;
}
